#!/usr/bin/python
# -*- coding: utf-8 -*-
#Numerazione progressiva Oggetti = o100

"""
x/p+y/q=1   rif. equazione segmentaria della retta

x = (1-y/q)*p   rif. equazione segmentaria della retta

y = (1-x/p)*q   rif. equazione segmentaria della retta

p =x/(1-y/q)    rif. equazione segmentaria della retta

q = y/(1-x/p)   rif. equazione segmentaria della retta

p = -c/a    rif. equazione segmentaria della retta

q = -c/b    rif. equazione segmentaria della retta


m = -a/b    rif. coefficente angolare della retta

m = m1    rif. Condizione di parallelismo di 2 rette

m = -1/m1    rif. Condizione di perpendicolaritÃ  di 2 retta



(x-x1)/(x2-x1)=(y-y1)/(y2-y1)
(x-x1)*(y2-y1)=(y-y1)*(x2-x1)
y2*x-y1*x-x1*y2+x1*y1=x2*y-x1*y-y1*x2+x1*y1
y2*x-y1*x-x1*y2+x1*y1-x2*y+x1*y+y1*x2-x1*y1=0
-x1*y2+x1*y1+y1*x2-x1*y1=0
(y2-y1)*x+(x1-x2)*y+(x2*y1-x1*y2)=0


"""

#Equazione della retta espressa in vari modi e correlati 
class equ_retta:
    def __init__(self):
        #print "Passato per Equazioni.equ_retta.__init__"
        nulla=None
    #Retta passante per 2 punti dati: Restituisce i coefficenti e il termine noto (a,b,c) dell'equazione
    #(ax+by+c=0) della retta passante per 2 punti di cordinate p1(x1,y1) e p2(x2,y2)
    def retta_p1_p2 (self,x1,y1,x2,y2):
        a = float(y2-y1)
        b = float(x1-x2)
        c = float(x2*y1-x1*y2)
        return a,b,c
    #Retta passante per 2 punti dati: Restituisce sotto forma di stringa l'equazione nel formato
    #(a*x+b*y+c=0) della retta passante per 2 punti di cordinate p1(x1,y1) e p2(x2,y2)
    def equ_retta_p1_p2 (self,x1,y1,x2,y2):
        a = (y2-y1)
        b = (x1-x2)
        c = (x2*y1-x1*y2)
        if (a!=0): pa1 = str(a)+"x"
        else: pa1 = ""
        if (b<0): pa2 = str(b)+"y"
        elif (b==0): pa2 = ""
        else: pa2 = "+"+str(b)+"y"
        if (c<0): pa3 = str(c)
        elif (c==0): pa3 = ""
        else: pa3 = "+"+str(c)
        if (a!=0) and (b!=0) and (c!=0): pa4 = "=0"
        else: pa4 = ""   
        eq_ret = pa1+pa2+pa3+pa4
        return eq_ret
    #Restituisce (l'incognita  x) dell'equazione (a*x+b*y+c=0) di una retta dati i valori di (a,b,c,y)
    def retta_val_x (self,a,b,c,y):
        x = (-b*y-c)/a
        return x
    #Restituisce (l'incognita  y) dell'equazione (a*x+b*y+c=0) di una retta dati i valori di (a,b,c,x)
    def retta_val_y (self,a,b,c,x):
        y = (-a*x-c)/b
        return y
    #Restituisce il (coefficente  a) dell'incognita (x) dell'equazione (a*x+b*y+c=0) di una retta dati
    #i valori di (b,c,x,y)
    def retta_val_a (self,b,c,x,y):
        a = (-b*y-c)/x
        return a
    #Restituisce il (coefficente  b) dell'incognita (y) dell'equazione (a*x+b*y+c=0) di una retta dati
    #i valori di (a,c,x,y)
    def retta_val_b (self,a,c,x,y):
        b = (-a*x-c)/y
        return b
    #Restituisce il (termine noto  c) dell'incognita (y) dell'equazione (a*x+b*y+c=0) di una retta dati
    #i valori di (a,c,x,y)
    def retta_val_c (self,a,b,c,y):
        x = (-b*y-c)/a
        return x
    #Restituisce le coordinate del (punto di intersezione) di 2 rette (a*x+b*y+c=0) e (a1*x+b1*y+c1=0)
    def rette_p_intersec (self,a,b,c,a1,b1,c1):
        y = (c*a1-a*c1)/(a*b1-b*a1)
        x = (-b*y-c)/a
        return x,y
    #Restituisce (l'incognita  x) dell'equazione segmentaria (x/p+y/q=1) di una retta dati i valori di
    #(y,p,q)
    def retta_seg_val_x (self,y,p,q):
        x = (1-y/q)*p
        return x
    #Restituisce (l'incognita  y) dell'equazione segmentaria (x/p+y/q=1) di una retta dati i valori di
    #(x,p,q)
    def retta_seg_val_y (self,x,p,q):
        y = (1-x/p)*q
        return y
    #Restituisce (l'incognita  p) dell'equazione segmentaria (x/p+y/q=1) di una retta dati i valori di
    #(x,y,q)
    def retta_seg_val_p (self,x,y,q):
        p =x/(1-y/q)
        return p
    #Restituisce (l'incognita  q) dell'equazione segmentaria (x/p+y/q=1) di una retta dati i valori di
    #(x,y,p)
    def retta_seg_val_q (self,x,y,p):
        q = y/(1-x/p)
        return q
    #Restituisce (l'incognita  p) dell'equazione segmentaria (x/p+y/q=1) di una retta dati i valori di
    #(a,c) dell'equazione della retta nella forma (a*x+b*y+c=0)
    def retta_seg_val_p_con_a_c (self,a,c):
        p = -c/a
        return p
    #Restituisce (l'incognita  q) dell'equazione segmentaria (x/p+y/q=1) o esplicita (y=m*x+q)di una
    #retta dati i valori di (b,c) dell'equazione della retta nella forma (a*x+b*y+c=0)
    def retta_seg_val_q_con_a_c (self,b,c):
        q = -c/b
        return q
    #Restituisce (il Coefficente angolare  m) dell'equazione esplicita(y=m*x+q) di una retta dati
    #i valori di (a,b) dell'equazione della retta nella forma (a*x+b*y+c=0)
    def retta_coef_ang_m (self,a,b):
        m = -a/b
        return m
    #Condizione di parallelismo:Restituisce (il Coefficente angolare  m) dell'equazione esplicita
    #(y=m*x+q) di una retta tale da comportare una situazione di parallelismo con una 2a retta esplicita
    #(y=m1*x+q)dato i coefficente angolare (m1)
    def rette_val_para (self,m1):
        m = m1
        return m
    #Condizione di parallelismo:Verifica una condizione di parallellismo restituendo (1) in caso
    #affermativo (0) in caso negativo dati i coefficenti angolari (m,m1) di 2 equazioni esplicte
    #rispettivamnete(y=m*x+q) e (y=m1*x+q) di 2 rette distinte.
    def rette_ver_para (self,m,m1):
        if (m == m1): para = 1
        else: para = 0
        return para
    #Condizione di perpendicolaritÃ :Restituisce (il Coefficente angolare  m) dell'equazione esplicita
    #(y=m*x+q) di una retta tale da comportare una situazione di perpendicolaritÃ  con una 2a retta esplicita
    #(y=m1*x+q)dato i coefficente angolare (m1)
    def rette_val_perp (self,m1):
        m = -1/m1
        return m
    #Condizione di perpendicolaritÃ :Verifica una condizione di perpendicolaritÃ  restituendo (1) in caso
    #affermativo (0) in caso negativo dati i coefficenti angolari (m,m1) di 2 equazioni esplicte
    #rispettivamnete(y=m*x+q) e (y=m1*x+q) di 2 rette distinte.
    def rette_ver_perp (self,m,m1):
        if (m == -1/m1): perp = 1
        else: perp = 0
        return perp

class intersez:
    def __init__(self):
        #print "Passato per Equazioni.equ_retta.__init__"
        nulla=None
    #Punto di intersezione delle equazioni di 2 rette
    def p_inter_2_ret (self,a,b,c,d,e,f):
        #print "def p_inter_2_ret (self,a,b,c,d,e,f)"
        y=((d*c)/a-f)/(-(d*b)/a+e)
        x=(-b*y-c)/a
        return x,y
    #Punto di intersezione delle equazioni di 1 rette con una 1 retta verticale
    def p_inter_1_ret_1_ret_v (self,a,b,c,x):
        #print "def p_inter_2_ret (self,a,b,c,d,e,f)"
        y=(-a*x-c)/b
        return y
    #Punto di intersezione delle equazioni di 1 rette con una 1 retta orizzontale
    def p_inter_1_ret_1_ret_o (self,a,b,c,y):
        #print "def p_inter_2_ret (self,a,b,c,d,e,f)"
        x=(-b*y-c)/a
        return x



